program MakeValid;
uses sysutils;


var
  Buf : array[0..$FFFFFF] of byte;
  LIA : array[0..$3FFFFF] of longint absolute Buf;
  F   : File;
  i,
  L   : longint;
  S   : String;
  D   : longint;

begin
  if ParamCount <> 1
  then begin
         writeln('Usage: MakeValid armcortexfile.bin');
         halt(3);
       end;
  S:= ParamStr(1);
  if not FileExists(S)
  then begin
         writeln('no file ',S);
         halt(2);
       end;

  Assign(F,S);
  Reset(F,1);
  L:= FileSize(F);
  if L>sizeof(Buf)
  then begin
         close(F);
         writeln('file too big.');
         halt(1);
       end;
  BlockRead(F,Buf,L);
  close(F);
  D:= 0;
  for i:= 0 to 6 do D:= D + LIA[i];
  D:= -D;
  LIA[7]:= D;

  rewrite(F,1);
  BlockWrite(F,Buf,L);
  close(F);
  writeln('Makevalid done, magic is ',IntToHex(D,8));
end.


